#include <extdll.h>
#include <sdk_util.h>
#include <dllapi.h>
#include <meta_api.h>
#include "vers_plugin.h"
#include "cbase.h"

#include "entity_state.h"

char *pDotSpriteName = "sprites/laserdot.spr";
int m_dotspriteTexture = 0;

typedef struct
{
	int UserID;
	edict_t *Eye;
	edict_t *curView;
} playerid_t;

playerid_t players[32];

#include "userid_list.h"
/*
inline bool FPlayerAlive	(edict_t *pent)	{return (pent->v.health>0);}
inline bool FPlayerDead		(edict_t *pent)	{return (pent->v.health<=0);}
inline bool FPlayerAlive	(int id)	{return (players[id].old_health>0);}
inline bool FPlayerDead		(int id)	{return (players[id].old_health<=0);}
*/
#define pEye (players[i].Eye)

inline void RemoveEye(int i) 
{
	if (!FNullEnt(pEye))
	{
		entvars_t *pev = VARS(pEye);
		pev->flags |= FL_KILLME;
		pev->targetname = 0;
		pEye=NULL;
	}
}

inline void CreateEye(int i, edict_t *pThis)
{
//	pEye=CREATE_NAMED_ENTITY(MAKE_STRING("info_landmark"));
//	pEye=CREATE_NAMED_ENTITY(MAKE_STRING("func_wall")); //func_wall is in all mods
	pEye=CREATE_ENTITY();
		
	entvars_t *pev = VARS(pEye);
	
//info_landmark is almost cbaseentity (only sets pev->solid == SOLID_NOT) and it's in all mods .. right?
//so it's ok we use this one.. 
//	CALL_GAME_ENTITY(PLID,"info_landmark",pev);

	pev->classname = MAKE_STRING("eye_plugin_playereye");

	pev->solid = SOLID_NOT;
	pev->movetype = MOVETYPE_NOCLIP;
	
//	pev->renderamt = 0;				// The engine won't draw this model if this is set to 0 and blending is on
//	pev->rendermode = kRenderTransTexture;

	pev->rendermode = kRenderGlow;
	pev->renderfx = kRenderFxNoDissipation;
	pev->renderamt = 255;
	
	SET_MODEL(pEye, pDotSpriteName);
	
	pev->owner	= pThis;
}

inline void UpdateEye(int i, edict_t *pThis)
{
	if (FNullEnt(pEye))
	{
		CreateEye(i,pThis);
	}
	
	entvars_t *pev = VARS(pEye);

	pev->angles	= pThis->v.v_angle;

	SET_ORIGIN(pEye, pThis->v.origin+pThis->v.view_ofs);
}

//from adminmod's extdll.h:
inline BOOL IsPlayerValid(CBaseEntity* pPlayer) {
  return ((pPlayer) && (!FNullEnt(pPlayer->pev)) && (GETPLAYERUSERID(pPlayer->edict()) > 0) && (!FStrEq(STRING(pPlayer->pev->netname),"")) ? TRUE : FALSE);
}

CBaseEntity* UTIL_PlayerByIndex( int playerIndex ){
  CBaseEntity* pPlayer = NULL;
  
  if ( playerIndex > 0 && playerIndex <= gpGlobals->maxClients ) {
    edict_t* pPlayerEdict = INDEXENT( playerIndex );
    if ( pPlayerEdict && !pPlayerEdict->free ) {
      pPlayer = CBaseEntity::Instance( pPlayerEdict );
    }
  }
  return pPlayer;
}

char *strstri(const char *s1, const char *s2)
{
	char *sd1=strdup(s1);
	char *sd2=strdup(s2);
	
	//Have to strdup first .. because we don't want to lower playernames :)
	const char *low_s1=strlwr(sd1);
	const char *low_s2=strlwr(sd2);

	const char *point;
	
	point=strstr(low_s1,low_s2);
	
	if (point==NULL)
	{
		free(sd2);
		free(sd1);
		return NULL;
	}
	
	for (unsigned int i=0; i<strlen(s1); i++) 
		if ((void *)point==(void *)(&low_s1[i]))
		{
			free(sd2);
			free(sd1);
			return (char *)(&s1[i]);
		}
	
	free(sd2);
	free(sd1);
	return NULL;
}

edict_t *GetView(const char *cmd)
{
	if (!cmd) return NULL;

	//ALERT(at_console,"cmd: %s\n",cmd);

	int pid=-1;
	
	if (cmd[0]=='#')
	{
		sscanf(&cmd[1],"%d",&pid);
		
		CBaseEntity* pPlayer = UTIL_PlayerByIndex(pid);
		
		if (!IsPlayerValid(pPlayer)) return NULL;
		
		edict_t *pThis = pPlayer->edict();
		
		//Get and check userid
		int userid=GETPLAYERUSERID(pThis);
		if (userid==-1)
		{
			return NULL;
		}

		//Check if in list !
		int listid=GetListIDByUserID(userid);
		if (listid==-1)
		{
			return NULL;
		}	
		
		return (players[listid].Eye);
	}
	
	for (int i = 1; i <= gpGlobals->maxClients; i++)
	{
		CBaseEntity* pPlayer = UTIL_PlayerByIndex(i);
	
		if (!IsPlayerValid(pPlayer))
			continue;
		
		if (strstri(STRING(pPlayer->pev->netname),cmd)==NULL)
			continue;

		edict_t *pThis=pPlayer->edict();
		
		//Get and check userid
		int userid=GETPLAYERUSERID(pThis);
		if (userid==-1)
		{
			return NULL;
		}

		//Check if in list !
		int listid=GetListIDByUserID(userid);
		if (listid==-1)
		{
			return NULL;
		}	
		
		return (players[listid].Eye);
	}
	
	return NULL;
}

void PlayerPostThink_Post( edict_t *pThis )
{
	if (!gpGlobals->deathmatch) RETURN_META(MRES_IGNORED);

	//Get and check userid
	int userid=GETPLAYERUSERID(pThis);
	if (userid==-1)
	{
		RETURN_META(MRES_IGNORED);
	}
	else if (pThis->v.spawnflags & SF_PLAYER_DISCONNECTED1 && pThis->v.spawnflags & SF_PLAYER_DISCONNECTED2)
	{
		RETURN_META(MRES_IGNORED);
	}
	
	//Check if in list !
	int listid=GetListIDByUserID(userid);

	//If not in list try if can add to list
	if (listid==-1)
	{
		listid=AddToUserList(userid);
		
		if (listid==-1)
		{
			RETURN_META(MRES_IGNORED);
		}
	}

/*	if (FPlayerDead(listid))	//Dude is dead .. check for respawn
	{
		if(FPlayerAlive(pThis))
		{
			//was dead .. now alive
		}
		else
		{
			//Still dead .. 
		}
	}
	else
	{
		//Was alive before .. check if is still alive!
		if(FPlayerAlive(pThis))
		{
			//yep .. player is still alive..
		}
		else
		{
			//was alive .. now dead
		}
	}
*/	
	UpdateEye(listid,pThis);
	
//	printf("Origin: %.2f %.2f %.2f -- Angles: %.2f %.2f %.2f\n",players[listid].Eye->v.origin.x,players[listid].Eye->v.origin.y,players[listid].Eye->v.origin.z,players[listid].Eye->v.angles.x,players[listid].Eye->v.angles.y,players[listid].Eye->v.angles.z);
	
	RETURN_META(MRES_HANDLED);
}

int AddToFullPack_Post(struct entity_state_s *state, int e, edict_t *ent, edict_t *pThis, int hostflags, int player, unsigned char *pSet)
{
	if (!gpGlobals->deathmatch) RETURN_META_VALUE(MRES_IGNORED,1);
	
	//Check if this entity has been stopped
	if (META_RESULT_STATUS>MRES_HANDLED) //override && supercede
	{
		if (!META_RESULT_OVERRIDE_RET(int))
		{
			//Stopped by other plugin .. 
			RETURN_META_VALUE(MRES_IGNORED,0);
		}
	}
	else if (!META_RESULT_ORIG_RET(int))
	{
		//Stopped by game dll .. 
		RETURN_META_VALUE(MRES_IGNORED,0);
	}
	
	//Get and check userid
	int userid=GETPLAYERUSERID(pThis);
	if (userid==-1)
	{
		RETURN_META_VALUE(MRES_IGNORED,0);
	}
	else if (pThis->v.spawnflags & SF_PLAYER_DISCONNECTED1 && pThis->v.spawnflags & SF_PLAYER_DISCONNECTED2)
	{
		RETURN_META_VALUE(MRES_IGNORED,0);
	}
	
	//Check if in list !
	int listid=GetListIDByUserID(userid);

	//If not in list try if can add to list
	if (listid==-1)
	{
		RETURN_META_VALUE(MRES_IGNORED,0);
	}
	
	//Not send model of current player .. It just would block all vis
	if (players[listid].curView && players[listid].curView->v.owner==ent)
		RETURN_META_VALUE(MRES_OVERRIDE,0);
	
	//Fast pre-check first .. then pointer compare
	bool IsOurView=false;
	if ((STRING(ent->v.classname))[0]=='e' && (STRING(ent->v.classname))[1]=='y' && (STRING(ent->v.classname))[2]=='e')
	{
		for (int i=0;i<gpGlobals->maxClients;i++)
		{
			if (players[i].Eye==ent)
			{
				IsOurView=true;
				state->modelindex=0;
				
				break;
			}
		}
	}
	
	if (!IsOurView)
	{
		RETURN_META_VALUE(MRES_IGNORED,0);
	}
	
	//It is our ent .. but it isn't used by this client .. don't send over network then
	if (players[listid].curView!=ent)
	{
		RETURN_META_VALUE(MRES_OVERRIDE,0);
	}
	
	RETURN_META_VALUE(MRES_IGNORED,0);
	return 0;
}

void ClientDisconnect_Post(edict_t *pThis)
{
	if (!gpGlobals->deathmatch) RETURN_META(MRES_IGNORED);
	
	int userid=GETPLAYERUSERID(pThis);
	if (userid==-1) RETURN_META(MRES_IGNORED);
	
	//HACK HACK! We have to set this on so UserID doesn't get add to list after disconnect!
	pThis->v.spawnflags|=(SF_PLAYER_DISCONNECTED1|SF_PLAYER_DISCONNECTED2);
	
	//Remove player from player id list
	int listid=GetListIDByUserID(userid);
	
	if (players[listid].UserID!=-1)
	{
		//Remove eyeball
		RemoveEye(listid);
		
		players[listid].Eye=NULL;
		players[listid].curView=NULL;
		players[listid].UserID=-1;
	}
	
	RETURN_META(MRES_IGNORED);
}

inline void Send_TextMsg(edict_t **client, int msg_dest, const char *msg_name)
{
	int message_TextMsg = GET_USER_MSG_ID(PLID,"TextMsg",NULL);
	
	if (!message_TextMsg || !client || !(*client) || (*client)->v.flags & FL_FAKECLIENT) return;
	
	MESSAGE_BEGIN( MSG_ONE, message_TextMsg, NULL, *client );
		WRITE_BYTE( msg_dest );
		WRITE_STRING( msg_name );
	MESSAGE_END();
}

void ClientCommand_Post( edict_t *pThis )
{
	if (!gpGlobals->deathmatch) RETURN_META(MRES_IGNORED);

	//Get and check userid
	int userid=GETPLAYERUSERID(pThis);
	if (userid==-1)
	{
		RETURN_META(MRES_IGNORED);
	}
	else if (pThis->v.spawnflags & SF_PLAYER_DISCONNECTED1 && pThis->v.spawnflags & SF_PLAYER_DISCONNECTED2)
	{
		RETURN_META(MRES_IGNORED);
	}
	
	//Check if in list !
	int listid=GetListIDByUserID(userid);

	//If not in list try if can add to list
	if (listid==-1)
	{
		RETURN_META(MRES_IGNORED);
	}
	
	const char *pcmd = CMD_ARGV(0);
	const char *saycmd  = CMD_ARGV(1);
	
	if (stricmp(pcmd,"say") && stricmp(pcmd,"say_team")) 
		RETURN_META(MRES_IGNORED);
	
	if (!stricmp(saycmd,"eye_back"))
	{
		Send_TextMsg(&pThis,HUD_PRINTTALK,"Reset to normal!\n\0");
		
		//Reset view to normal
		SET_VIEW(pThis,pThis);
		
		players[listid].curView=NULL;
	}
	else if ((!stricmp(saycmd,"eye") && CMD_ARGV(2)) || !strncmpi(saycmd,"eye ",4))
	{
		edict_t *pView;
		
		if (!strncmpi(saycmd,"eye ",4)) 
		{
			static char cmdtmp[128];
			static char tmp[5];
						
			cmdtmp[0]=0;
			
			sscanf(saycmd,"%s %s",tmp,cmdtmp);
			
			if (strlen(cmdtmp)<1) RETURN_META(MRES_HANDLED);
		
			pView=GetView(cmdtmp);
		}
		else
		{
			pView=GetView(CMD_ARGV(2));
		}
		
		if (!FNullEnt(pView))
		{
			static char OutPut[256];
			sprintf(OutPut,"Setting view to '%s'!\n\0",STRING(pView->v.owner->v.netname));
			OutPut[255]=0;
			
			Send_TextMsg(&pThis,HUD_PRINTTALK,OutPut);
			
			SET_VIEW(pThis,pView);
			
			players[listid].curView=pView;
		}
	}
	
	RETURN_META(MRES_HANDLED);
}

int DispatchSpawn_Post( edict_t *pent )
{	
	if (!gpGlobals->deathmatch) RETURN_META_VALUE(MRES_IGNORED, 0);

	//On every level start:
	char *pClassname = (char *)STRING(pent->v.classname);
	if (!stricmp(pClassname, "worldspawn"))
	{
		m_dotspriteTexture   = PRECACHE_MODEL(pDotSpriteName);
		
		for (int i=0;i<32;i++)
		{
			players[i].Eye=NULL;
			players[i].curView=NULL;
			players[i].UserID=-1;
		}
	}
	
	RETURN_META_VALUE(MRES_HANDLED, 0);
	return 0;
}

static DLL_FUNCTIONS gFunctionTable_Post =
{
	NULL,						//! pfnGameInit()
	DispatchSpawn_Post,				//! pfnSpawn()
	NULL,						//! pfnThink()
	NULL,						//! pfnUse()
	NULL,						//! pfnTouch()
	NULL,						//! pfnBlocked()
	NULL,						//! pfnKeyValue()
	NULL,						//! pfnSave()
	NULL,						//! pfnRestore()
	NULL,						//! pfnSetAbsBox()

	NULL,						//! pfnSaveWriteFields()
	NULL,						//! pfnSaveReadFields()

	NULL,						//! pfnSaveGlobalState()
	NULL,						//! pfnRestoreGlobalState()
	NULL,						//! pfnResetGlobalState()

	NULL,						//! pfnClientConnect()
	ClientDisconnect_Post,				//! pfnClientDisconnect()
	NULL,						//! pfnClientKill()
	NULL,						//! pfnClientPutInServer()
	ClientCommand_Post,				//! pfnClientCommand()
	NULL,						//! pfnClientUserInfoChanged()
	NULL,						//! pfnServerActivate()
	NULL,						//! pfnServerDeactivate()

	NULL,						//! pfnPlayerPreThink()
	PlayerPostThink_Post,				//! pfnPlayerPostThink()

	NULL,						//! pfnStartFrame()
	NULL,						//! pfnParmsNewLevel()
	NULL,						//! pfnParmsChangeLevel()

	NULL,						//! pfnGetGameDescription()
	NULL,						//! pfnPlayerCustomization()

	NULL,						//! pfnSpectatorConnect()
	NULL,						//! pfnSpectatorDisconnect()
	NULL,						//! pfnSpectatorThink()

	NULL,						//! pfnSys_Error()

	NULL,						//! pfnPM_Move()
	NULL,						//! pfnPM_Init()
	NULL,						//! pfnPM_FindTextureType()

	NULL,						//! pfnSetupVisibility()
	NULL,						//! pfnUpdateClientData()
	AddToFullPack_Post,				//! pfnAddToFullPack()
	NULL,						//! pfnCreateBaseline()
	NULL,						//! pfnRegisterEncoders()
	NULL,						//! pfnGetWeaponData()
	NULL,						//! pfnCmdStart()
	NULL,						//! pfnCmdEnd()
	NULL,						//! pfnConnectionlessPacket()
	NULL,						//! pfnGetHullBounds()
	NULL,						//! pfnCreateInstancedBaselines()
	NULL,						//! pfnInconsistentFile()
	NULL,						//! pfnAllowLagCompensation()
};

C_DLLEXPORT int GetEntityAPI2_Post( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
	LOG_DEVELOPER(PLID, "called: GetEntityAPI2_Post; version=%d", *interfaceVersion);
	if(!pFunctionTable) {
		LOG_ERROR(PLID, "GetEntityAPI2_Post called with null pFunctionTable");
		return(FALSE);
	}
	else if(*interfaceVersion != INTERFACE_VERSION) {
		LOG_ERROR(PLID, "GetEntityAPI2_Post version mismatch; requested=%d ours=%d", *interfaceVersion, INTERFACE_VERSION);
		//! Tell engine what version we had, so it can figure out who is out of date.
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy( pFunctionTable, &gFunctionTable_Post, sizeof( DLL_FUNCTIONS ) );
	return(TRUE);
}

