#include <extdll.h>
#include <meta_api.h>
#include "plugin.h"
#include "vers_plugin.h"

//#include <sdk_util.h>		// REG_SVR_COMMAND, etc

#define COMPILE_TIME (const char *)(__DATE__ ", " __TIME__)

// Must provide at least one of these..
META_FUNCTIONS gMetaFunctionTable = {
	NULL,			// pfnGetEntityAPI			HL SDK;		called before game DLL
	NULL,			// pfnGetEntityAPI_Post			META;		called after game DLL
	NULL,			// pfnGetEntityAPI2			HL SDK2;	called before game DLL
	GetEntityAPI2_Post,	// pfnGetEntityAPI2_Post		META;		called after game DLL
	NULL,			// pfnGetNewDLLFunctions		HL SDK2;	called before game DLL
	NULL,			// pfnGetNewDLLFunctions_Post		META;		called after game DLL
	NULL,			// pfnGetEngineFunctions		META;		called before HL engine
	NULL,			// pfnGetEngineFunctions_Post		META;		called after HL engine
};

typedef struct
{
	int UserID;
	edict_t *Eye;
	edict_t *curView;
} playerid_t;

extern playerid_t players[32];

// Plugin startup.  Register commands and cvars.
void plugin_init(void)
{
	LOG_MESSAGE(PLID, "%s v%s, %s", Plugin_info.name, Plugin_info.version, Plugin_info.date);
	LOG_MESSAGE(PLID, "by %s", Plugin_info.author);
	LOG_MESSAGE(PLID, "   %s", Plugin_info.url);
	LOG_MESSAGE(PLID, "compiled: %s EET", COMPILE_TIME);
	
	for (int i=0;i<32;i++)
	{
		players[i].Eye=NULL;
		players[i].curView=NULL;
		players[i].UserID=-1;
	}
}

